//-----------------------------------------
// LScript Generic template
//

@version 2.2
@warnings
@script generic

// global values go here
dissolveval=0.0;

generic
{
	mysel=Scene().getSelect();
	if(!mysel || mysel[1].genus!=MESH)
		return;
	for(i=1;i<=mysel.size();i++)
	{
		myobj=mysel[i];
		Dissolve(myobj,dissolveval);
	}
	SelectItems(mysel);
}

Dissolve:pobj,pval
{
	mychan=pobj.firstChannel();
	while(mychan)
	{
		if(mychan.name=="Dissolve")
		{

			if(mychan.keyCount>0)
			{
				mykey=mychan.keys[1];
				mycurve=mychan.getKeyCurve(mykey);
				mynewkey=mychan.createKey(Scene().currenttime,pval);
				mychan.setKeyCurve(mynewkey,mycurve);
				if(mycurve==CHAN_HERMITE)
					mychan.setKeyHermite(mynewkey,mychan.getKeyHermite(mykey));
				else if(mycurve==CHAN_TCB)
				{
					mychan.setKeyTension(mynewkey,mychan.getKeyTension(mykey));
					mychan.setKeyContinuity(mynewkey,mychan.getKeyContinuity(mykey));
					mychan.setKeyBias(mynewkey,mychan.getKeyBias(mykey));
				}
			}
			else
			{
				mynewkey=mychan.createKey(Scene().currenttime,pval);
				mychan.setKeyCurve(mynewkey,CHAN_STEPPED);
			}
			return;
		}
		mychan=pobj.nextChannel();
	}
	SelectItem(pobj.id);
	ObjectDissolve(0);
// 	AddEnvelope("Dissolve");
// 	mychan=pobj.firstChannel();
// 	while(mychan.name!="Dissolve")
// 	{
// 		mychan=pobj.nextChannel();
// 	}
// 	mykey=mychan.keys[1];
// 	mynewkey=mychan.createKey(Scene().currenttime,pval);
// 	mychan.setKeyCurve(mynewkey,CHAN_STEPPED);
// 	if(Scene().currenttime!=0)
// 		mychan.deleteKey(mykey);
	return;
}

SelectItems:plist
{
    SelectItem(plist[1].id);
    for(i=2;i<=plist.size();i++)
    {
        AddToSelection(plist[i].id);
    }
}

